//SEU2010

package seu.states;

import java.util.Collection;
import java.util.List;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.worldmodel.Property;
import seu.entities.Path;



public abstract class AreaState extends EntityState
{
	private Area me;
	
	public AreaState(Area me) {
		super(me);
		this.me = me;
	}
	
	public abstract Collection getNeighborhood(StandardWorldModel world);
	
	//TODO
	public abstract List<Path> getContainedPaths(StandardWorldModel world);
	
	public String toString(){
	      return super.toString();
	}
	
	public void setProperty(StandardWorldModel world, int time, Property type, int[] value)
	{
		if(type == me.getBlockadesProperty()){
			//TODO
//			me.setBlockades(value);
		}
		else if(type == me.getEdgesProperty()){
			//TODO
//			me.setEdges(value);
		}
		else if(type == me.getXProperty()){
			me.setX(value[0]);
		}
		else if(type == me.getYProperty()){
			me.setY(value[0]);
		}
	}
	
	private boolean m_isAreaChecked = false;
	
	public void setAreaChecked(boolean bool){
		m_isAreaChecked = bool;
	}
	
	public boolean getAreaChecked(){
		return m_isAreaChecked;
	}
	
	public double civPossiblity = 0;
	
	public double civTotalPossiblity = 0;
	

}