//SEU2010

package seu.states;

import rescuecore2.standard.entities.*;
import rescuecore2.worldmodel.EntityID;
import rescuecore2.worldmodel.Property;
import seu.SeuConstants;

public class BlockadeState extends EntityState{

	private Blockade me;
	
	public BlockadeState(Blockade me) {
		super(me);
		this.me = me;
	}

//	public int getType(){
//		return SeuConstants.TYPE_BLOCKADE;
//	}
	
	public void setProperty(StandardWorldModel world, int time, Property type, int[] value)
	{
		if(type == me.getApexesProperty()){
			me.setApexes(value);
		}
		else if(type == me.getPositionProperty()){
			me.setPosition(new EntityID(value[0]));
		}
		else if(type == me.getRepairCostProperty()){
			me.setRepairCost(value[0]);
		}
		else if(type == me.getXProperty()){
			me.setX(value[0]);
		}
		else if(type == me.getYProperty()){
			me.setY(value[0]);
		}
		else{
			super.setProperty(world, time, type, value);
		}
	}
	
}