
package seu.utilities.base;
public class SingleData<T> implements Cloneable{
	private final T obj;
	private final int time;
	private final boolean isSee;
	public SingleData(T obj, int time,boolean isSee){
		this.obj = obj;
		this.time = time;
		this.isSee = isSee;
	}
	
	public SingleData(T obj ,int time){
		this(obj,time,true);
	}
	
	public T getObject(){
		return obj;
	}

	
	public int getTime(){
		return time;
	}
	
	public boolean isSee(){
		return isSee;
	}
	
	public SingleData<T> clone(){
		SingleData<T> data = new SingleData<T>(obj,time,isSee);
		return data;
	}
	
}
